RepHeaderRemember = LibStub("AceAddon-3.0"):NewAddon("RepHeaderRemember", "AceConsole-3.0", "AceHook-3.0")

local defaults = {
	profile = {
		HeaderCollapsed = {}
	},
}

-- Called when the addon is loaded
function RepHeaderRemember:OnInitialize()
--	self:Print("in init")
	self.db = LibStub("AceDB-3.0"):New("RepHeaderRememberDB", defaults)
end

-- Called when the addon is enabled
function RepHeaderRemember:OnEnable()
--	self:Print("in enable")
	
	RepHeaderRemember:Hook("ReputationFrame_Update", true)
	RepHeaderRemember:Hook("CollapseFactionHeader", true)
	RepHeaderRemember:Hook("ExpandFactionHeader", true)
end

-- Saves the name of a header that was collapsed
function RepHeaderRemember:CollapseFactionHeader(index, ...)
	name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
	if (isHeader) then 
--		self:Print("CollapseFactionHeader hook")
		self.db.profile.HeaderCollapsed[name] = true
	end
	
	self.hooks["CollapseFactionHeader"](index, ...)
end

-- Saves the name of a header that was expanded
function RepHeaderRemember:ExpandFactionHeader(index, ...)
	name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
	if (isHeader) then 
--		self:Print("ExpandFactionHeader hook")
		self.db.profile.HeaderCollapsed[name] = false
	end
	
	self.hooks["ExpandFactionHeader"](index, ...)
end

-- If Rep frame is being shown, collapse headers.
function RepHeaderRemember:ReputationFrame_Update(...)
--	self:Print("ReputationFrame_Update hook")
	self:CollapseHeaders()

	self.hooks["ReputationFrame_Update"](...)
end

-- Reads list of saved header names and collapses or expands them to match saved value.
function RepHeaderRemember:CollapseHeaders()
	for index=1, GetNumFactions(), 1 do
		name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
		if isHeader and self.db.profile.HeaderCollapsed[name] ~= nil then
--			self:Print("header found: " .. name)
			if self.db.profile.HeaderCollapsed[name] and not isCollapsed then
--				self:Print("collapsing " .. name)
				CollapseFactionHeader(index)
			elseif not self.db.profile.HeaderCollapsed[name] and isCollapsed then
--				self:Print("expanding " .. name)
				ExpandFactionHeader(index) 
			end
		end
	end
end

